#! /usr/bin/env bash

if [ "${POSTGRES_SLAVE_MODE}" != 1 ]
then
  echo "Database is not in slave mode. Exiting."
  exit 0
fi

replace_pg_conf()
{
  var_name="${1}"
  var_value="${2}"
  sed -ri "s!^#?(${var_name})\s*=\s*\S+.*!\1 = ${var_value}!" /var/lib/postgresql/data/postgresql.conf
}

replace_pg_conf wal_level replica
replace_pg_conf max_wal_senders 3
replace_pg_conf wal_keep_segments 8
replace_pg_conf hot_standby on
